#DEFINE LINKFILES
#DEFINE WIN64

#INCLUDE "windows.h"
#INCLUDE "Commctrl.h"

HM STRUCT
	hWnd dq ?
	cnt  dq ?
ENDS

WndProcThunk STRUCT
    RcxMov dw ?		; mov rcx, pThis
    RcxImm dq ?		; 
    RaxMov dw ?		; mov rax, target
    RaxImm dq ?		; 
    RaxJmp dw ?		; jmp target
ENDS

DATA
	ALIGN 8
	classname  db "dummy",0
	ALIGN 8
	im_bad     db "I'M BAD!"
	ALIGN 8
	im_rel_bad db "I'M REALLY REALLY BAD!"
	ALIGN 8
	glob_heap  dq ?
	hInstance  dq ?
	test_con1  dq ?
	test_con2  dq ?
	ALIGN 8

CONST
	TESTM_INCCOUNT equ WM_USER+1
	
CODE

START:
	invoke GetModuleHandle, 0
	mov	   [hInstance], rax
	invoke GetProcessHeap
	mov    [glob_heap], rax
    invoke InitCommonControls
    invoke CreateClass
	invoke DialogBoxParam, [hInstance], 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0

CreateClass frame
	LOCAL  wc:WNDCLASSEX

	mov	   D[wc.cbSize],      SIZEOF WNDCLASSEX
	mov    D[wc.style],       CS_GLOBALCLASS
	mov    rax, OFFSET DummyProc
	mov	   Q[wc.lpfnWndProc], rax
	mov    D[wc.cbClsExtra],  0
	mov	   D[wc.cbWndExtra],  0
	mov    rax, [hInstance]
	mov	   Q[wc.hInstance], rax
	mov	   Q[wc.hbrBackground], 0
	mov	   Q[wc.lpszMenuName],  0
	mov    rax, OFFSET classname
	mov	   Q[wc.lpszClassName], rax
	mov	   rax, 0
	mov	   Q[wc.hIcon],   rax
	mov	   Q[wc.hIconSm], rax
	invoke LoadCursor, 0, IDC_ARROW
	mov	   Q[wc.hCursor], rax
	invoke RegisterClassEx, ADDR wc
	ret

endf

; This is where magic happens
DummyProc frame hWin, uMsg, wParam, lParam
	uses rsi
	; allocate two structures for saving unique properties
	mov    r10, SIZEOF HM            ; control properties
	add    r10, SIZEOF WndProcThunk  ; thunk code

	invoke VirtualAlloc, 0, r10, MEM_COMMIT, PAGE_EXECUTE_READWRITE

	mov    rcx, [hWin]
	mov    Q[HM.hWnd+rax], rcx
	mov    Q[HM.cnt+rax], 0
	mov    rsi, rax
	add    rsi, SIZEOF HM
		
	; figure out relative address
	mov    rcx, OFFSET TestConProc	
	
	mov    W[rsi +0], 0B948h
	mov    Q[rsi +2], rax
	mov    W[rsi+10], 0B848h
	mov    Q[rsi+12], rcx
	mov    W[rsi+20], 0E0FFh
	
	invoke SetWindowLongPtr, [hWin], GWLP_WNDPROC, rsi
	
	invoke rsi, [hWin], [uMsg], [wParam], [lParam]
	
	ret
		
endf

; rcx rdx r8 r9
TestConProc frame hWin, uMsg, wParam, lParam
	USES rbx, rsi
	LOCAL ps:PAINTSTRUCT

	mov    rbx, rcx
	cmp    rdx, TESTM_INCCOUNT
	jnz    >
		mov    rax, [HM.cnt+rbx]
		inc    rax
		mov    [HM.cnt+rbx], rax
		invoke InvalidateRect, [HM.hWnd+rbx], 0, 1
		jmp    >>.exit
	:
	cmp    rdx, WM_PAINT
	jnz    >>
		invoke BeginPaint, [HM.hWnd+rbx], ADDR ps
		invoke GetParent,  [HM.hWnd+rbx]
		invoke SendMessage, rax, WM_GETFONT, 0, 0
		invoke SelectObject, [ps.hdc], rax
		invoke SetBkColor,   [ps.hdc], 0ffffffh
		invoke ExtTextOut,   [ps.hdc], 0, 0, ETO_OPAQUE, ADDR ps.rcPaint, 0, 0, 0
		invoke SetTextColor, [ps.hdc], 0
		mov    rsi, [HM.cnt+ebx]
		test   rsi, rsi
		jz     >@no_bad
		@more:
		dec    rsi
		mov    r12, rsi
		shl    r12, 4
		invoke ExtTextOut, [ps.hdc], 0, r12, ETO_OPAQUE, 0, ADDR im_bad, 8, 0
		test   rsi, rsi
		jnz    @more
		@no_bad:
		mov    r12, [HM.cnt+rbx]
		shl    r12, 4
		invoke ExtTextOut, [ps.hdc], 0, r12, ETO_OPAQUE, 0, ADDR im_rel_bad, 22, 0
		invoke EndPaint, [HM.hWnd+rbx], ADDR ps
		jmp    >.exit
	:
	cmp    rdx, WM_NCDESTROY
	jnz    >
		invoke VirtualFree, rbx, 0, MEM_RELEASE
		jmp    >.exit
	:	
		invoke DefWindowProc, [HM.hWnd+rbx], [uMsg], [wParam], [lParam]
		ret
	.exit
	
	xor    rax, rax
	ret

endf

DlgProc frame hWin, uMsg, wParam, lParam

	cmp    rdx, WM_INITDIALOG
	jnz    >>
		invoke CreateWindowEx,  WS_EX_STATICEDGE, ADDR classname, 0, WS_CHILD+WS_VISIBLE, 10, 40, 180, 200, [hWin], 0, [hInstance], 0
		mov    [test_con1], rax

		invoke CreateWindowEx, WS_EX_STATICEDGE, ADDR classname, 0, WS_CHILD+WS_VISIBLE, 200, 40, 180, 200, [hWin], 0, [hInstance], 0
		mov    [test_con2], rax
		jmp    >>.exit
	:
	cmp    rdx, WM_COMMAND
	jnz    >
		cmp    r8, 1001
		jnz    >.next_item
			invoke SendMessage, [test_con1], TESTM_INCCOUNT, 0, 0
			jmp    >.outta
		.next_item
		cmp    r8, 1002
		jnz    >.outta
			invoke SendMessage, [test_con2], TESTM_INCCOUNT, 0, 0
		.outta
		jmp    >.exit
	:
	cmp    rdx, WM_CLOSE
	jnz   >
		invoke EndDialog, [hWin], 0
		jmp    >.exit
	:
		xor		rax, rax
		ret
	.exit
	mov		rax, 1
	ret

endf

